﻿using Android.App;
using Android.OS;
using Android.Runtime;
using Android.Webkit;
using Android.Widget;
using AndroidX.AppCompat.App;
using LyricShow.WebInterop;
using Newtonsoft.Json;

namespace LyricShow.Droid
{
    [Activity(Label = "LyricShow", MainLauncher = true)]
    public class MainActivity : AppCompatActivity
    {
        private WebView _mainWebView;


        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);

            FindViewById<Button>(Resource.Id.PutButton).Click += PutButton_Click;

#if DEBUG
            WebView.SetWebContentsDebuggingEnabled(true);
#endif
            _mainWebView = FindViewById<WebView>(Resource.Id.MainWebView);
            _mainWebView.Settings.JavaScriptEnabled = true;

            _mainWebView.LoadUrl("https://dev.topcl.net/");
        }

        private void PutButton_Click(object sender, System.EventArgs e)
        {
            PutLyricShowData("Brrrrrrrrr from Xamarin Android");
        }

        private void PutLyricShowData(object obj)
        {
            _mainWebView.EvaluateJavascript($"putLyricShowData({JsonConvert.SerializeObject(obj)})", null);
        }

        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }
}