using Microsoft.AspNetCore.Components.WebAssembly.Hosting;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Net.Http;
using System.Threading.Tasks;
using LyricShow.WebContent.Pages;
using Microsoft.JSInterop;

namespace LyricShow.WebContent
{
    public class Program
    {
        internal static IndexPage IndexPage;

        [JSInvokable]
        public static void PutLyricData(object obj)
        {
            IndexPage?.PutLyricData(obj);
        }

        public static async Task Main(string[] args)
        {
            var builder = WebAssemblyHostBuilder.CreateDefault(args);
            builder.RootComponents.Add<IndexPage>("#app");

            builder.Services.AddScoped(sp => new HttpClient { BaseAddress = new Uri(builder.HostEnvironment.BaseAddress) });

            await builder.Build().RunAsync();
        }
    }
}
